org.h2.expression

## Class Expression

- java.lang.Object
- - org.h2.expression.Expression

Direct Known Subclasses:
  Alias, BinaryOperation, CompareLike, Comparison, ConditionAndOr, ConditionExists, ConditionIn, ConditionInConstantSet, ConditionInParameter, ConditionInSelect, ConditionNot, DataAnalysisOperation, ExpressionColumn, ExpressionList, Function, IntervalOperation, JavaFunction, Parameter, Rownum, SequenceValue, Subquery, UnaryOperation, ValueExpression, Variable, Wildcard

    public abstract class Expression
    extends java.lang.Object

An expression is a operation, a value, or a function in a query.

### Field Summary

Fields
`static int` `MAP_IN_AGGREGATE` State for expressions inside an aggregate for `mapColumns(ColumnResolver, int, int)`.
`static int` `MAP_IN_WINDOW` State for expressions inside a window function for `mapColumns(ColumnResolver, int, int)`.
`static int` `MAP_INITIAL` Initial state for `mapColumns(ColumnResolver, int, int)`.

### Constructor Summary

Constructors
Constructor and Description
`Expression()`

### Method Summary

Methods
`void` `addFilterConditions(TableFilter filter, boolean outerJoin)` Add conditions to a table filter if they can be evaluated.
`void` `createIndexConditions(Session session, TableFilter filter)` Create index conditions if possible and attach them to the table filter.
`java.lang.String` `getAlias()` Get the alias name of a column or SQL expression if it is not an aliased expression.
`boolean` `getBooleanValue(Session session)` Get the value in form of a boolean expression.
`java.lang.String` `getColumnName()` Get the column name or alias name of this expression.
`abstract int` `getCost()` Estimate the cost to process the expression.
`Expression[]` `getExpressionColumns(Session session)` If this expression consists of column expressions it should return them.
`static Expression[]` `getExpressionColumns(Session session, ResultInterface result)` Extracts expression columns from the given result set.
`protected static Expression[]` `getExpressionColumns(Session session, ValueCollectionBase value)` Extracts expression columns from ValueArray
`Expression` `getNonAliasExpression()` Returns the main expression, skipping aliases.
`Expression` `getNotIfPossible(Session session)` If it is possible, return the negated expression.
`int` `getNullable()` Check whether this expression is a column and can store NULL.
`java.lang.String` `getSchemaName()` Get the schema name, or null
`java.lang.String` `getSQL(boolean alwaysQuote)` Get the SQL statement of this expression.
`abstract java.lang.StringBuilder` `getSQL(java.lang.StringBuilder builder, boolean alwaysQuote)` Appends the SQL statement of this expression to the specified builder.
`Expression` `getSubexpression(int index)` Returns subexpression with specified index.
`int` `getSubexpressionCount()` Returns count of subexpressions.
`java.lang.String` `getTableAlias()` Get the table alias name or null if this expression does not represent a column.
`java.lang.String` `getTableName()` Get the table name, or null
`abstract TypeInfo` `getType()` Returns the data type.
`java.lang.StringBuilder` `getUnenclosedSQL(java.lang.StringBuilder builder, boolean alwaysQuote)` Appends the SQL statement of this expression to the specified builder.
`abstract Value` `getValue(Session session)` Return the resulting value for the current row.
`boolean` `isAutoIncrement()` Check if this is an auto-increment column.
`boolean` `isConstant()` Check if this expression will always return the same value.
`abstract boolean` `isEverything(ExpressionVisitor visitor)` Check if this expression and all sub-expressions can fulfill a criteria.
`boolean` `isGeneratedKey()` Check if this expression is an auto-generated key expression such as next value from a sequence.
`boolean` `isValueSet()` Is the value of a parameter set.
`abstract void` `mapColumns(ColumnResolver resolver, int level, int state)` Map the columns of the resolver to expression columns.
`abstract Expression` `optimize(Session session)` Try to optimize the expression.
`abstract void` `setEvaluatable(TableFilter tableFilter, boolean value)` Tell the expression columns whether the table filter can return values now.
`java.lang.String` `toString()` Convert this expression to a String.
`abstract void` `updateAggregate(Session session, int stage)` Update an aggregate value.
`static void` `writeExpressions(java.lang.StringBuilder builder, Expression[] expressions, boolean alwaysQuote)` Get the SQL snippet for an array of expressions.
`static void` `writeExpressions(java.lang.StringBuilder builder, java.util.List<? extends Expression> expressions, boolean alwaysQuote)` Get the SQL snippet for a list of expressions.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### MAP_INITIAL

    public static final int MAP_INITIAL

Initial state for `mapColumns(ColumnResolver, int, int)`.

See Also:
  Constant Field Values

#### MAP_IN_WINDOW

    public static final int MAP_IN_WINDOW

State for expressions inside a window function for `mapColumns(ColumnResolver, int, int)`.

See Also:
  Constant Field Values

#### MAP_IN_AGGREGATE

    public static final int MAP_IN_AGGREGATE

State for expressions inside an aggregate for `mapColumns(ColumnResolver, int, int)`.

See Also:
  Constant Field Values

### Constructor Detail

#### Expression

    public Expression()

### Method Detail

#### writeExpressions

    public static void writeExpressions(java.lang.StringBuilder builder,
                        java.util.List<? extends Expression> expressions,
                        boolean alwaysQuote)

Get the SQL snippet for a list of expressions.

Parameters:
  `builder` - the builder to append the SQL to
  `expressions` - the list of expressions
  `alwaysQuote` - quote all identifiers

#### writeExpressions

    public static void writeExpressions(java.lang.StringBuilder builder,
                        Expression[] expressions,
                        boolean alwaysQuote)

Get the SQL snippet for an array of expressions.

Parameters:
  `builder` - the builder to append the SQL to
  `expressions` - the list of expressions
  `alwaysQuote` - quote all identifiers

#### getValue

    public abstract Value getValue(Session session)

Return the resulting value for the current row.

Parameters:
  `session` - the session
Returns:
  the result

#### getType

    public abstract TypeInfo getType()

Returns the data type. The data type may not be known before the optimization phase.

Returns:
  the data type

#### mapColumns

    public abstract void mapColumns(ColumnResolver resolver,
                  int level,
                  int state)

Map the columns of the resolver to expression columns.

Parameters:
  `resolver` - the column resolver
  `level` - the subquery nesting level
  `state` - current state for nesting checks, initial value is `MAP_INITIAL`

#### optimize

    public abstract Expression optimize(Session session)

Try to optimize the expression.

Parameters:
  `session` - the session
Returns:
  the optimized expression

#### setEvaluatable

    public abstract void setEvaluatable(TableFilter tableFilter,
                      boolean value)

Tell the expression columns whether the table filter can return values now. This is used when optimizing the query.

Parameters:
  `tableFilter` - the table filter
  `value` - true if the table filter can return value

#### getSQL

    public java.lang.String getSQL(boolean alwaysQuote)

Get the SQL statement of this expression. This may not always be the original SQL statement, specially after optimization.

Parameters:
  `alwaysQuote` - quote all identifiers
Returns:
  the SQL statement

#### getSQL

    public abstract java.lang.StringBuilder getSQL(java.lang.StringBuilder builder,
                                 boolean alwaysQuote)

Appends the SQL statement of this expression to the specified builder. This may not always be the original SQL statement, specially after optimization.

Parameters:
  `builder` - string builder
  `alwaysQuote` - quote all identifiers
Returns:
  the specified string builder

#### getUnenclosedSQL

    public java.lang.StringBuilder getUnenclosedSQL(java.lang.StringBuilder builder,
                                           boolean alwaysQuote)

Appends the SQL statement of this expression to the specified builder. This may not always be the original SQL statement, specially after optimization. Enclosing '(' and ')' are removed.

Parameters:
  `builder` - string builder
  `alwaysQuote` - quote all identifiers
Returns:
  the specified string builder

#### updateAggregate

    public abstract void updateAggregate(Session session,
                       int stage)

Update an aggregate value. This method is called at statement execution time. It is usually called once for each row, but if the expression is used multiple times (for example in the column list, and as part of the HAVING expression) it is called multiple times - the row counter needs to be used to make sure the internal state is only updated once.

Parameters:
  `session` - the session
  `stage` - select stage

#### isEverything

    public abstract boolean isEverything(ExpressionVisitor visitor)

Check if this expression and all sub-expressions can fulfill a criteria. If any part returns false, the result is false.

Parameters:
  `visitor` - the visitor
Returns:
  if the criteria can be fulfilled

#### getCost

    public abstract int getCost()

Estimate the cost to process the expression. Used when optimizing the query, to calculate the query plan with the lowest estimated cost.

Returns:
  the estimated cost

#### getNotIfPossible

    public Expression getNotIfPossible(Session session)

If it is possible, return the negated expression. This is used to optimize NOT expressions: NOT ID>10 can be converted to ID<=10. Returns null if negating is not possible.

Parameters:
  `session` - the session
Returns:
  the negated expression, or null

#### isConstant

    public boolean isConstant()

Check if this expression will always return the same value.

Returns:
  if the expression is constant

#### isValueSet

    public boolean isValueSet()

Is the value of a parameter set.

Returns:
  true if set

#### isAutoIncrement

    public boolean isAutoIncrement()

Check if this is an auto-increment column.

Returns:
  true if it is an auto-increment column

#### isGeneratedKey

    public boolean isGeneratedKey()

Check if this expression is an auto-generated key expression such as next value from a sequence.

Returns:
  whether this expression is an auto-generated key expression

#### getBooleanValue

    public boolean getBooleanValue(Session session)

Get the value in form of a boolean expression. Returns true or false. In this database, everything can be a condition.

Parameters:
  `session` - the session
Returns:
  the result

#### createIndexConditions

    public void createIndexConditions(Session session,
                             TableFilter filter)

Create index conditions if possible and attach them to the table filter.

Parameters:
  `session` - the session
  `filter` - the table filter

#### getColumnName

    public java.lang.String getColumnName()

Get the column name or alias name of this expression.

Returns:
  the column name

#### getSchemaName

    public java.lang.String getSchemaName()

Get the schema name, or null

Returns:
  the schema name

#### getTableName

    public java.lang.String getTableName()

Get the table name, or null

Returns:
  the table name

#### getNullable

    public int getNullable()

Check whether this expression is a column and can store NULL.

Returns:
  whether NULL is allowed

#### getTableAlias

    public java.lang.String getTableAlias()

Get the table alias name or null if this expression does not represent a column.

Returns:
  the table alias name

#### getAlias

    public java.lang.String getAlias()

Get the alias name of a column or SQL expression if it is not an aliased expression.

Returns:
  the alias name

#### getNonAliasExpression

    public Expression getNonAliasExpression()

Returns the main expression, skipping aliases.

Returns:
  the expression

#### addFilterConditions

    public void addFilterConditions(TableFilter filter,
                           boolean outerJoin)

Add conditions to a table filter if they can be evaluated.

Parameters:
  `filter` - the table filter
  `outerJoin` - if the expression is part of an outer join

#### toString

    public java.lang.String toString()

Convert this expression to a String.

Overrides:
  `toString` in class `java.lang.Object`
Returns:
  the string representation

#### getExpressionColumns

    public Expression[] getExpressionColumns(Session session)

If this expression consists of column expressions it should return them.

Parameters:
  `session` - the session
Returns:
  array of expression columns if applicable, null otherwise

#### getExpressionColumns

    protected static Expression[] getExpressionColumns(Session session,
                                    ValueCollectionBase value)

Extracts expression columns from ValueArray

Parameters:
  `session` - the current session
  `value` - the value to extract columns from
Returns:
  array of expression columns

#### getExpressionColumns

    public static Expression[] getExpressionColumns(Session session,
                                    ResultInterface result)

Extracts expression columns from the given result set.

Parameters:
  `session` - the session
  `result` - the result
Returns:
  an array of expression columns

#### getSubexpressionCount

    public int getSubexpressionCount()

Returns count of subexpressions.

Returns:
  count of subexpressions

#### getSubexpression

    public Expression getSubexpression(int index)

Returns subexpression with specified index.

Parameters:
  `index` - 0-based index
Returns:
  subexpression with specified index
Throws:
  `java.lang.IndexOutOfBoundsException` - if specified index is not valid